apiVersion: apps/v1
kind: Deployment
metadata:
  name: ur-fastapi
  labels:
    app.kubernetes.io/name: ur-fastapi
    app.kubernetes.io/instance: api-v1
spec:
  selector:
    matchLabels:
      app.kubernetes.io/name: ur-fastapi
      app.kubernetes.io/instance: api-v1
  replicas: 1
  strategy:
    type: Recreate
  template:
    metadata:
      labels:
        app.kubernetes.io/name: ur-fastapi
        app.kubernetes.io/instance: api-v1
    spec:
      containers:
        - name: ur-fastapi
          image: 'registry.gitlab.com/alexander.ganster/ur-fastapi:latest'
          ports:
            - name: metrics
              containerPort: 8000
              protocol: TCP
            - name: api
              containerPort: 8080
              protocol: TCP
          livenessProbe:
            httpGet:
              path: /
              port: 8080
              scheme: HTTP
          securityContext:
            readOnlyRootFilesystem: true
            runAsGroup: 200385
            runAsNonRoot: true
            runAsUser: 200385
            # shoudl be default anyways, just adding to be extra save
            allowPrivilegeEscalation: false
            capabilities:
              drop:
              - ALL
            privileged: false
      imagePullSecrets:
        - name: imagepullsecret-gitlab.com
---
apiVersion: v1
kind: Service
metadata:
  name: ur-fastapi
  labels:
    app.kubernetes.io/name: ur-fastapi
    app.kubernetes.io/instance: api-v1
spec:
  type: ClusterIP
  ports:
    - port: 8080
      targetPort: api
      protocol: TCP
      name: api
    - port: 8000
      targetPort: metrics
      protocol: TCP
      name: metrics
  selector:
    app.kubernetes.io/name: ur-fastapi
    app.kubernetes.io/instance: api-v1

